package org.springblade.modules.martial.controller;

import com.baomidou.mybatisplus.core.metadata.IPage;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.tags.Tag;
import lombok.AllArgsConstructor;
import org.springblade.core.boot.ctrl.BladeController;
import org.springblade.core.mp.support.Condition;
import org.springblade.core.mp.support.Query;
import org.springblade.core.tool.api.R;
import org.springblade.core.tool.utils.Func;
import org.springblade.modules.martial.pojo.entity.MartialJudgeInvite;
import org.springblade.modules.martial.service.IMartialJudgeInviteService;
import org.springframework.web.bind.annotation.*;

/**
 * 裁判邀请码 控制器
 *
 * @author BladeX
 */
@RestController
@AllArgsConstructor
@RequestMapping("/martial/judgeInvite")
@Tag(name = "裁判邀请码管理", description = "裁判邀请码接口")
public class MartialJudgeInviteController extends BladeController {

	private final IMartialJudgeInviteService judgeInviteService;

	/**
	 * 详情
	 */
	@GetMapping("/detail")
	@Operation(summary = "详情", description = "传入ID")
	public R<MartialJudgeInvite> detail(@RequestParam Long id) {
		MartialJudgeInvite detail = judgeInviteService.getById(id);
		return R.data(detail);
	}

	/**
	 * 分页列表
	 */
	@GetMapping("/list")
	@Operation(summary = "分页列表", description = "分页查询")
	public R<IPage<MartialJudgeInvite>> list(MartialJudgeInvite judgeInvite, Query query) {
		IPage<MartialJudgeInvite> pages = judgeInviteService.page(Condition.getPage(query), Condition.getQueryWrapper(judgeInvite));
		return R.data(pages);
	}

	/**
	 * 新增或修改
	 */
	@PostMapping("/submit")
	@Operation(summary = "新增或修改", description = "传入实体")
	public R submit(@RequestBody MartialJudgeInvite judgeInvite) {
		return R.status(judgeInviteService.saveOrUpdate(judgeInvite));
	}

	/**
	 * 删除
	 */
	@PostMapping("/remove")
	@Operation(summary = "删除", description = "传入ID")
	public R remove(@RequestParam String ids) {
		return R.status(judgeInviteService.removeByIds(Func.toLongList(ids)));
	}

}
